//Motor-Zeug
#include <AccelStepper.h>


//Stepper definieren
AccelStepper stepper1(AccelStepper::FULL2WIRE, 2, 3);
AccelStepper stepper2(AccelStepper::FULL2WIRE, 4, 5);

//Farbsensor Pins
#define S0 10
#define S1 9
#define S2 8
#define S3 7
#define sensorOut 6

//USM Pins
//rechts
const int trig1Pin = 19;
const int echo1Pin = 16;
//links
const int trig2Pin = 18;
const int echo2Pin = 13;



void setup() {

  // Farbsensor Pins
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);

  // Setting frequency-scaling to 20%
  digitalWrite(S0, HIGH);
  digitalWrite(S1, HIGH);


  //USM Pins
  //Rechts:
  pinMode(trig1Pin, OUTPUT);
  pinMode(echo1Pin, INPUT);
  digitalWrite(trig1Pin, LOW);
  //Links:
  pinMode(trig2Pin, OUTPUT);
  pinMode(echo2Pin, INPUT);
  digitalWrite(trig2Pin, LOW);

  //Stepper
  //rechts
  stepper1.setMaxSpeed(2000.0);
  stepper1.setSpeed(1000.0);
  //links
  stepper2.setMaxSpeed(2000.0);
  stepper2.setSpeed(-1000.0); // Wert muss beim geradeaus Fahren negativ sein, da d. Stepper sich sonst am Roboter in entgegengesetzte Richtugen drehen würden

  Serial.begin(115200);

}

void loop() {
  // Farbsensor
  while (Rot() >= 10 && Blau() >= 13) {
    stepper1.setSpeed(1000.0);
    stepper2.setSpeed(-1000.0);
    stepper1.runSpeed();
    stepper2.runSpeed();
  }
  while (Rot() <= 10 ) {
    stepper1.setSpeed(-1000.0);
    stepper1.runSpeed();
    stepper2.runSpeed();
  }

  while (Blau() <= 13) {
    stepper2.setSpeed(1000.0);
    stepper1.runSpeed();
    stepper2.runSpeed();
  }

  //Ultraschallsensoren
  while (USMLinks() <= 5) {
    stepper1.setSpeed(1700);
    stepper1.runSpeed();
    stepper2.runSpeed();
  }

  while (USMRechts() <= 5) {
    stepper2.setSpeed(-1700);
    stepper1.runSpeed();
    stepper2.runSpeed();
  }
  stepper1.setSpeed(1000.0);
  stepper2.setSpeed(-1000.0);
  stepper1.runSpeed();
  stepper2.runSpeed();
}


//FUNKTIONEN

// RGB-Sensor
float Rot() {
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
  float FrequenzROT = pulseIn(sensorOut, LOW);
  //Serial.print("R= ");
  //Serial.print(FrequenzROT);
  //Serial.println("  ");
  return (FrequenzROT);
}

float Grun() {
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);
  float FrequenzGRUN = pulseIn(sensorOut, LOW);
  //Serial.print("G= ");
  //Serial.print(FrequenzGRUN);
  //Serial.print("  ");
  // Serial.print("\t");
  return (FrequenzGRUN);
}

float Blau() {
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  float FrequenzBLAU = pulseIn(sensorOut, LOW);
  //Serial.print("B= ");
  //Serial.print(FrequenzBLAU);
  //Serial.print("  ");
  // Serial.print("\t");
  return (FrequenzBLAU);
}

//Ultraschallsensoren (Abstandsmesser)

long USMRechts() {
  long Dauer1;
  int cm1;
  digitalWrite(trig1Pin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trig1Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig1Pin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  Dauer1 = pulseIn(echo1Pin, HIGH);
  // Calculating the distance
  cm1 = Dauer1 * 0.034 / 2;
  // Prints the distance on the Serial Monitor
  Serial.print(cm1);
  Serial.print("cm ");
  Serial.println();
  return (cm1 );
}
long USMLinks() {
  long Dauer2;
  int cm2;
  digitalWrite(trig2Pin, LOW);
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trig2Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig2Pin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  Dauer2 = pulseIn(echo2Pin, HIGH);
  // Calculating the distance
  cm2 = Dauer2 * 0.034 / 2;
  // Prints the distance on the Serial Monitor
  Serial.print(cm2);
  Serial.print("cm ");
  Serial.println();
  return (cm2);
}

long microsecondsToCentimeters(long microseconds) {
  // Schallgeschwindigkeit: 340 m/s oder 29mikrosek./cm
  // Das vom trig-pin ausgehende Signal geht den Weg zum objekt hin und zurück, also wird der Wert halbiert um auf die Entferung zum Sensor zu kommen
  return microseconds / 29 / 2;
}
